import hypermedia.video.*;

import processing.opengl.*;
import librarytests.*;
import org.openkinect.*;
import org.openkinect.processing.*;



//-------------------------- START HERE --------------------------
/* John says, this is the same as the basicDepth sketch, but I added some fun stuff
this sketch demos how to get an actual image from the kinect camera.
anything i've added to the original sketch will be marked by //added
or //added + comment
*/
Kinect kinect;
int ds =20; //added 
int minDepth = 300; //added
int maxDepth = 2000; //added
PImage col;//added this gets used to store the actual camera input (like Capture class)
/************************************************************
Setup routine - initialize the kinect sensor
************************************************************/
void setup(){
  size(640*2,480*2,OPENGL);                          //set the size to match sensor resolution
  kinect = new Kinect(this);              //create a new sensor object
  kinect.start();                         //start the kinect sensor 
  kinect.enableDepth(true);               //for now enable depth feed
  kinect.tilt(15); 
  kinect.enableRGB(true);  
}

/************************************************************
Draw routine - actually draw the pixels on the screen
************************************************************/
void draw(){
  background(255);                                              //make a black background
  //stroke(255);                                                //stroke is white
  col = kinect.getVideoImage(); //added + get video stream out of kinect
  int[] depthMap = kinect.getRawDepth(); //grab the raw depth map from sensor
  int w = 640, h = 480;                                       //this is the resolution of depth map
  for(int x = 0; x < w-ds; x+=ds){                                 //scan through the entire depth map 
    for(int y = 0; y < h-ds; y+=ds){ 
        
      int index = y * w + x;
      float depth = rawDepthToMeters(depthMap[index])*1000;
      float depthx = rawDepthToMeters(depthMap[index+ds])*1000;
      float depthy = rawDepthToMeters(depthMap[index+width])*1000;
      float depthxy = rawDepthToMeters(depthMap[index+width+ds])*1000;
      color c = col.get(x,y); //added + gets color from the image we create
      if(depth > minDepth && depth < maxDepth) {
        pushMatrix();//added+ between push and pop have fun drawing!
          translate(x*2,y*2,100-map(depth,minDepth,maxDepth,0,2000));
          //rotateX(map(depth,minDepth,maxDepth,0,TWO_PI)+float(frameCount)/ds);
          //rotateY(map(depth,minDepth,maxDepth,0,TWO_PI)+float(frameCount)/ds);
          //rotateZ(map(depth,minDepth,maxDepth,0,TWO_PI));
          fill(c);
           
          // fill(255);
           stroke(0);
           scale(map(depth,minDepth,maxDepth,2,.1));
           box(ds*5);
         popMatrix();
     
      }      //if the depth at this point is within these constraints, draw it
    }
  }
  
}

/*********************************************************************
  Convert raw depth value to real world depth in meters
**********************************************************************/
float rawDepthToMeters(int depthValue) {
    if (depthValue < 10000) {
      return (float)(1.0 / ((double)(depthValue) * -0.0030711016 + 3.3309495161));
    }
    return 0.0f;
}

//added: save out
void keyPressed() {
saveFrame("####.png");

}
